<template>
  <div class="c-filter-list">
    <b-row>
      <b-col lg="5">
        <div class="c-filter">
          <b-form-input
            v-model.lazy="search"
            placeholder="Search for a country ...."
            @input="filterBySearch"
          />
        </div>
      </b-col>
      <b-col lg="3" offset-lg="1">
        <div class="c-filter">
          <b-form-select
            v-model="selected"
            :options="regionOptions"
            @change="filterByRegion"
          />
        </div>
      </b-col>
      <b-col lg="3">
        <div class="c-filter">
          <b-form-select
            v-model="sort"
            :options="sortOptions"
            @change="sortBy"
          />
        </div>
      </b-col>
    </b-row>
  </div>
</template>

<script>
import { mapMutations } from 'vuex'
export default {
  data() {
    return {
      selected: null,
      regionOptions: [
        { value: null, text: 'Filter By Region' },
        { value: 'Africa', text: 'Africa' },
        { value: 'America', text: 'America' },
        { value: 'Asia', text: 'Asia' },
        { value: 'Europe', text: 'Europe' },
        { value: 'Oceania', text: 'Oceania' },
        { value: 'Polar', text: 'Polar' },
      ],
      sort: null,
      sortOptions: [
        { value: null, text: 'Sort By' },
        { value: 'name', text: 'Country Name' },
        { value: 'population-asc', text: 'Population(asc)' },
        { value: 'population-desc', text: 'Population(desc)' },
      ],
      search: '',
    }
  },
  methods: {
    ...mapMutations({
      addRegion: 'countries/SET_COUNTRIES_BY_REGION',
      addSearch: 'countries/SET_COUNTRIES_BY_SEARCH',
      addSort: 'countries/SET_COUNTRIES_BY_SORT',
    }),
    filterByRegion() {
      this.addRegion({ region: this.selected })
    },
    filterBySearch() {
      this.addSearch({ value: this.search })
    },
    sortBy() {
      this.addSort({ value: this.sort })
    },
  },
}
</script>

<style lang="scss" scoped>
.c-filter-list {
  padding-bottom: 50px;
}
@media (max-width: 767px) {
  .c-filter {
    margin-bottom: 20px;
  }
}
</style>
